
(define (domain mirror-ninja)
    (:requirements :strips :equality)
  (:types location ninja mirror)
  (:predicates 
   (at-ninja ?n - ninja ?loc - location)
   (at-mirror ?n - mirror ?loc - location)
   (adjacent-north ?loc1 ?loc2 - location)
   (adjacent-south ?loc1 ?loc2 - location)
   (adjacent-east ?loc1 ?loc2 - location)
   (adjacent-west ?loc1 ?loc2 - location)
   )
  (:action move-north
	   :parameters (?n - ninja ?cn - mirror ?from ?to - location
			   ?loc ?loc-to - location)
	   :precondition (and
			  (at-ninja ?n ?from)
			  (at-mirror ?cn ?loc)
			  (not (= ?n ?cn))
			  (adjacent-north ?from ?to)
			  (adjacent-south ?loc ?loc-to))
	   :effect (and
		    (not (at-ninja ?n ?from))
		    (at-ninja ?n ?to)
		    (not (at-mirror ?cn ?loc))
		    (at-mirror ?cn ?loc-to)))
		    
  (:action move-south
	   :parameters (?n - ninja ?cn - mirror ?from ?to - location
			   ?loc ?loc-to - location)
	   :precondition (and
			  (at-ninja ?n ?from)
			  (at-mirror ?cn ?loc)
			  (not (= ?n ?cn))						  
			  (adjacent-south ?from ?to)
			  (adjacent-north ?loc ?loc-to))
	   :effect (and
		    (not (at-ninja ?n ?from))
		    (at-ninja ?n ?to)
		    (not (at-mirror ?cn ?loc))
		    (at-mirror ?cn ?loc-to)))

  (:action move-east
	   :parameters (?n - ninja ?cn - mirror ?from ?to - location
			   ?loc ?loc-to - location)
	   :precondition (and
			  (at-ninja ?n ?from)
			  (at-mirror ?cn ?loc)
			  (not (= ?n ?cn))
			  (adjacent-east ?from ?to)
			  (adjacent-east ?loc ?loc-to))
	   :effect (and
		    (not (at-ninja ?n ?from))
		    (at-ninja ?n ?to)
		    (not (at-mirror ?cn ?loc))
		    (at-mirror ?cn ?loc-to)))

  (:action move-west
	   :parameters (?n - ninja ?cn - mirror ?from ?to - location
			   ?loc ?loc-to - location)
	   :precondition (and
			  (at-ninja ?n ?from)
			  (at-mirror ?cn ?loc)
			  (not (= ?n ?cn))
			  (adjacent-west ?from ?to)
			  (adjacent-west ?loc ?loc-to))
	   :effect (and
		    (not (at-ninja ?n ?from))
		    (at-ninja ?n ?to)
		    (not (at-mirror ?cn ?loc))
		    (at-mirror ?cn ?loc-to)))
  )
